import { GraphQLResolveInfo, GraphQLSchema } from 'graphql';
import { IResolvers } from 'graphql-tools/dist/Interfaces';
import { QueryMap, BindingOptions, SubscriptionMap, Operation } from './types';
export declare class Binding<TQueryMap extends object = QueryMap, TSubscriptionMap extends object = SubscriptionMap> {
    query: TQueryMap;
    mutation: TQueryMap;
    subscription: TSubscriptionMap;
    schema: GraphQLSchema;
    before: () => void;
    private fragmentReplacements;
    constructor({schema, fragmentReplacements, before, handler, subscriptionHandler, link, typeDefs}: BindingOptions);
    request<T = any>(query: string, variables?: {
        [key: string]: any;
    }): Promise<T>;
    delegate(operation: Operation, fieldName: string, args: {
        [key: string]: any;
    }, info?: GraphQLResolveInfo | string, context?: {
        [key: string]: any;
    }): Promise<any>;
    delegateSubscription(fieldName: string, args?: {
        [key: string]: any;
    }, infoOrQuery?: GraphQLResolveInfo | string, context?: {
        [key: string]: any;
    }): Promise<AsyncIterator<any>>;
    getAbstractResolvers(filterSchema?: GraphQLSchema | string): IResolvers;
}
