import { GraphQLSchema } from 'graphql';
import { FragmentReplacements } from './types';
export declare type Operation = 'query' | 'mutation';
export declare type Before = () => void;
export declare function makeProxy<T extends object = any>({schema, fragmentReplacements, operation, before, handler}: {
    schema: GraphQLSchema;
    fragmentReplacements: FragmentReplacements;
    operation: Operation;
    before: Before;
    handler?: {
        new <T extends object>(schema: GraphQLSchema, fragmentReplacements: FragmentReplacements, operation: Operation, before: Before): ProxyHandler<T>;
    };
}): T;
export declare function makeSubscriptionProxy<T extends object = any>({schema, fragmentReplacements, before, handler}: {
    schema: GraphQLSchema;
    fragmentReplacements: FragmentReplacements;
    before: Before;
    handler?: {
        new <T extends object>(schema: GraphQLSchema, fragmentReplacements: FragmentReplacements, before: Before): ProxyHandler<T>;
    };
}): T;
